summaryrefslogtreecommitdiffstats
path: root/roles/common/files/etc/network
diff options
context:
space:
mode:
authorGuilhem Moulin <guilhem@fripost.org>2013-11-03 05:54:11 +0100
committerGuilhem Moulin <guilhem@fripost.org>2015-06-07 02:50:35 +0200
commit2bcaaf01a5fcc2d2ce618da6af30a43a70d03d80 (patch)
tree020bd450fbc622e49c7284f70785749c31aa4429 /roles/common/files/etc/network
parent6c30a3f5a131b6e628b588c0723d5e5374e115e1 (diff)
Use a dedicated, non-routable, IPv4 for IPSec.
At the each IPSec end-point the traffic is DNAT'ed to / MASQUERADE'd from our dedicated IP after ESP decapsulation. Also, some IP tables ensure that alien (not coming from / going to the tunnel end-point) is dropped.
Diffstat (limited to 'roles/common/files/etc/network')
-rwxr-xr-xroles/common/files/etc/network/if-post-down.d/iptables27
-rwxr-xr-xroles/common/files/etc/network/if-up.d/ipsec44
2 files changed, 71 insertions, 0 deletions
diff --git a/roles/common/files/etc/network/if-post-down.d/iptables b/roles/common/files/etc/network/if-post-down.d/iptables
new file mode 100755
index 0000000..944ff3a
--- /dev/null
+++ b/roles/common/files/etc/network/if-post-down.d/iptables
@@ -0,0 +1,27 @@
+#!/bin/sh
+#
+# A post-down hook to flush ip tables and delete custom chains in the
+# loaded v4 and v6 rulesets.
+#
+# Copyright 2013 Guilhem Moulin <guilhem@fripost.org>
+#
+# Licensed under the GNU GPL version 3 or higher.
+#
+
+set -ue
+PATH=/usr/sbin:/usr/bin:/sbin:/bin
+
+# Ignore the loopback interface; run the script for ifdown only.
+[ "$IFACE" != lo -a "$MODE" = stop ] || exit 0
+
+case "$ADDRFAM" in
+ inet) ipts=/sbin/iptables-save; ipt=/sbin/iptables;;
+ inet6) ipts=/sbin/ip6tables-save; ipt=/sbin/ip6tables;;
+ *) exit 0
+esac
+
+$ipts | sed -nr 's/^\*//p' | \
+while read table; do
+ $ipt -t "$table" -F
+ $ipt -t "$table" -X
+done
diff --git a/roles/common/files/etc/network/if-up.d/ipsec b/roles/common/files/etc/network/if-up.d/ipsec
new file mode 100755
index 0000000..e21d6ea
--- /dev/null
+++ b/roles/common/files/etc/network/if-up.d/ipsec
@@ -0,0 +1,44 @@
+#!/bin/sh
+#
+# A post-up/down hook to automatically create/delete a 'sec' VLAN
+# device, and a dedicated, host-scoped, IP for IPSec (v4 only).
+#
+# Copyright 2013 Guilhem Moulin <guilhem@fripost.org>
+#
+# Licensed under the GNU GPL version 3 or higher.
+#
+
+set -ue
+PATH=/usr/sbin:/usr/bin:/sbin:/bin
+
+if=sec0
+ip=172.16.0.1/32
+
+# Ignore the loopback interface and non inet4 families.
+[ "$IFACE" != lo -a "$ADDRFAM" = inet ] || exit 0
+
+# Only the device with the default, globally-scoped route, is of
+# interest here.
+[ "$( /bin/ip -4 route show to default scope global \
+ | sed -nr '/^default via \S+ dev (\S+).*/ {s//\1/p;q}' )" \
+ = \
+ "$IFACE" ] || exit 0
+
+case "$MODE" in
+ start) # Don't create $if if it's already there
+ /bin/ip -o link show | grep -qE "^[0-9]+:\s+$if" && exit 0
+
+ # Create a new VLAN $IFACE on physical device $if. This is
+ # required otherwise charon thinks the left peer is that
+ # host-scoped, non-routable IP.
+ /bin/ip link add link "$IFACE" name "$if" type vlan id 2713
+ /bin/ip address add "$ip" dev "$if" scope host
+ /bin/ip link set dev "$if" up
+ ;;
+ stop) # Don't create $if if it's no there
+ /bin/ip -o link show | grep -qE "^[0-9]+:\s+$if" || exit 0
+
+ # Deactivate the VLAN
+ /bin/ip link set dev "$if" down
+ ;;
+esac